#include <easysax.h>
#include <stdio.h>
//#include <assert.h>

void PrintAtt (AttValue av) {

	printf ("att->%s<-", av.attribute);
	printf ("\n");
	return;
}

void PrintVal (AttValue av) {

	printf ("val->%s<-", av.value);
	printf ("\n");
	return;
}

void PrintA (AttValue av) {

	PrintAtt (av);
	PrintVal (av);
	return;
}

void PrintText (Text text) {

	printf ("text->%s<-", text);
	printf ("\n");
	return;
}

void PrintOpen (Text text) {

	printf ("open->%s<-", text);
	printf ("\n");
	return;
}

void PrintClose (Text text) {

	printf ("close->%s<-", text);
	printf ("\n");
	return;
}

void PrintD () {

	printf ("\n");
	printf ("*declaration*");
	printf ("\n");
	return;
}

void PrintE (Text text) {

	printf ("error->%s<-", text);
	printf ("\n");
	return;
}

int main () {
		
		CString string = "  \n \
						   <!DOCTYPE <> []xren > \n \
						   <!ENTITY xren > \n \
						   <!NOTATION xren > \n \
						   <![ if statement ]]> \n \
						   <![CDATA[   xren!! ]]  ]]> \n \
						   <!ATTLIST xren > \n \
						   <!ELEMENT xren > \n \
						   <!-- comment -- comment --> \n \
						   <?xmp  pdspfs     ?> \n \
						   <!-- comment -- comment --> \n \
						   <?xmL version=\"1.0\" encoding =  'koi8r' ?> \n \
						   <!-- comment -- comment --> \n \
						   <THIS_IS_OPEN_TAG1 open=\'1\'> \n \
						   </THIS_IS_CLOSE_TAG1> \n \
						   <THIS_IS_OPEN_TAG2 open = \' 2 \"> this is text </THIS_IS_CLOSE_TAG2> \n \
						   <null_tag /> \n \
						   <qw attribute1 =\"  value1 \" attribute2 =\"  value2 \" />";

		printf ("\n---------------------------------------\n");
		printf (string);
		printf ("\n---------------------------------------\n");
		
		CBuffer buffer = InitCBufferFromString (string);

		EasyParser parser = InitEasyParser (buffer, &PrintText, &PrintOpen, &PrintClose, &PrintA, &PrintD, &PrintE);

		if (Parse (parser)) {

			printf ("\ngood!\n");
		}

		else {

			printf ("\nfalse!\n");
		}

		
		DestroyEasyParser (parser);
		DestroyCBuffer (buffer);
		return 0;
}
