#include <demirror.h>
#include <stdio.h>


int main () {

	DeMirror dm = InitDeMirror ();

	const char* str = "01234&56789&lt;&gt;&lt&gtabcd_&_&a_&am_&amp_&amp;_end";

	const char* str2 = DecodeDeMirror (dm, str);
	printf ("1->%s<-\n", str2);

	const char* str3 = "abcd&efgh&lt;&gt;&lt&gtabcd_&_&a_&ap_&apo_&apos_&apos;_end";
	const char* str4 = DecodeDeMirror (dm, str3);
	printf ("2->%s<-\n", str4);
	
	const char* str5 = "ABCD&EFGH&lt;&gt;&lt&gtabcd_&_&q_&qu_&quo_&quot_&quot;_end";
	const char* str6 = DecodeDeMirror (dm, str5);
	printf ("3->%s<-\n", str6);
	
	const char* str7 = "";
	const char* str8 = DecodeDeMirror (dm, str7);
	printf ("4->%s<-\n", str8);

	DestroyDeMirror (dm);
	return 0;
}
