#include <easysax.h>
#include <stdio.h>
//#include <assert.h>

void PrintAtt (AttValue av) {

	printf ("att->%s<-", av.attribute);
	printf ("\n");
	return;
}

void PrintVal (AttValue av) {

	printf ("val->%s<-", av.value);
	printf ("\n");
	return;
}

void PrintA (AttValue av) {

	PrintAtt (av);
	PrintVal (av);
	return;
}

void PrintText (Text text) {

	printf ("text->%s<-", text);
	printf ("\n");
	return;
}

void PrintOpen (Text text) {

	printf ("open->%s<-", text);
	printf ("\n");
	return;
}

void PrintClose (Text text) {

	printf ("close->%s<-", text);
	printf ("\n");
	return;
}

void PrintD () {

	printf ("\n");
	printf ("*declaration*");
	printf ("\n");
	return;
}

void PrintE (Text text) {

	printf ("error->%s<-", text);
	printf ("\n");
	return;
}

int main () {


		FILE* f = fopen ("event.xml", "rb");

		CBuffer buffer = InitCBufferFromFD (f);

		EasyParser parser = InitEasyParser (buffer, &PrintText, &PrintOpen, &PrintClose, &PrintA, &PrintD, &PrintE);

		if (Parse (parser)) {

			printf ("\ngood!\n");
		}

		else {

			printf ("\nfalse!\n");
		}

		
		DestroyEasyParser (parser);
		DestroyCBuffer (buffer);
		fclose (f);
		return 0;
}
