#include <easysaxatt.h>
#include <stdio.h>

void PrintAtt (AttValue av) {

	printf ("att->%s<-", av.attribute);
	printf ("\n");
	return;
}

void PrintVal (AttValue av) {

	printf ("val->%s<-", av.value);
	printf ("\n");
	return;
}

void Print (AttValue av) {

	PrintAtt (av);
	PrintVal (av);
	return;
}

int main () {
		
		CString string = "attribute1=\"value1\" attribute2 =\"  value2 \' attribute3 =  \'value3\" ";

		CBuffer buffer = InitCBufferFromString (string);

		EasyParserAtt parserAtt = InitEasyParserAtt (buffer, &Print);

		if (ParseAtt (parserAtt)) {

			printf ("\ngood!\n");
		}

		else {

			printf ("\nfalse!\n");
		}

		
		DestroyEasyParserAtt (parserAtt);
		DestroyCBuffer (buffer);
		return 0;
}
