#include <stdio.h>
#include <rmvdelimiter.h>

int main () {

		RemoverDelimiter rd = InitRemoverDelimiter ();
		
		if (rd == NULL) {

			return 1;
		}
		
		const char* string1 = " 		test1				 ";
		printf ("->%s<-\n", RemoveDelimiter (rd, string1));

		const char* string2 = " 	test2 test2 test2					 ";
		printf ("->%s<-\n", RemoveDelimiter (rd, string2));

		const char* string3 = " 	 ";
		printf ("->%s<-\n", RemoveDelimiter (rd, string3));
		
		const char* string4 = "";
		printf ("->%s<-\n", RemoveDelimiter (rd, string4));
		
		const char* string5 = " left";
		printf ("->%s<-\n", RemoveDelimiter (rd, string5));
		
		const char* string6 = "right ";
		printf ("->%s<-\n", RemoveDelimiter (rd, string6));
		
		const char* string7 = "end";
		printf ("->%s<-\n", RemoveDelimiter (rd, string7));

		const char* string8 = " 1 ";
		printf ("example: >%s<\n", string8);
		printf ("->%s<-\n", RemoveDelimiter (rd, string8));

		DestroyRemoverDelimiter (rd);
		return 0;
}
